/* Declarations for RDM routines */

int rdm_setup (int * kindx);
int rdm_parsesym (char * line, int lenl, void (*chk_func)(),
                  char * badtok, int maxb, char * errstr, int maxe);
int rdm_set_symm (char * valstr, int lenv, char * errstr, int maxe);
void rdm_reset_symm (int idum);
int rdm_symm_chreset (int ichan);
int rdm_symm_changed (int ichan);
int rdm_get_symm (int * nspg, char * spgname, int maxs, char * pgname,
                  int maxp, int * nsymmp, int * nsymm, 
                  float rsm[192][4][4], float rsmi[192][4][4]);
int rdm_get_spgrp (int * nspg, char * spgname, int maxs,  
                    int * nsymmp, int * nsymm);
int rdm_get_nsym (int * nsymm);
void rdm_get_sylat (char * syst, int maxs, char * latt, int maxl);
void rdm_symm_str (int isym, char * str, int maxs);
void rdm_symm_list (char * outstr, int maxo, void (*op_func)());
void rdm_symm_write (char * outstr, int maxo, void (*op_func)());
int rdm_sysabs (int ih, int ik, int il);
int rdm_sysahk (int ih, int ik, int il);
int rdm_asuput (int *ihkl, int *jhkl, int *isym);
int rdm_asuget (int *ihkl, int isym,  int *jhkl);
int rdm_centr (int *ihkl, int *ic);
int rdm_getrotations (int kindx, int iset, float * rotstart, float * rotend,
                      float * rots2, float * rote2,
                      float * rots3, float * rote3,
                      float * rots4, float * rote4,
                      float * rots5, float * rote5,
                      float * oscang, int nimg[], int * numimg);
int rdm_numimg (int kindx, int iset, int * numimg); 
int rdm_rot_start (int kindx, int iset, int imgnum, float * rot_start); 
int rdm_getimgpars (int kindx, int iset, int * iftype, int * ityp, 
                    int * lhead, int * lrec, int * iorder, int * iswap, 
                    int * irotn, int * nxrasts, int * nyrasts);
int rdm_getdetpars (int kindx, int iset, float * ctod, 
                    float * tau1, float * tau2, float * tau3,
                    float detr[], float deta[], float s0[3]);
int rdm_getcellwave (int kindx, int iset, float * cell, float * wave); 
int rdm_getcentre (int kindx, int iset, int imgnum, 
                  float * x_cen, float * y_cen,
                  float *x_c, float *y_c, float * w_c, float * coswc,
                  float * sinwc, float * xcmid, float * ycmid); 
int rdm_getdistor (int kindx, int iset, int imgnum, int * idtype, 
                   float * twist, float * tilt, float * y_scale, 
                   float * roff, float * toff); 
int rdm_getmmrast (int kindx, int iset, float * mm_rast_x, float * mm_rast_y); 
int rdm_write (int kdx, int ioptyp, int ichanged, int isymm, 
                char * outstr, int maxo, void (*op_func)());
void rdm_mosdet (float ctod, float tau1, float tau2, float tau3,
                float detr[], float deta[], float dd[3][3], 
                float ddinv[3][3], float dn[]);
void rdm_bmatrx (float * cell, float wave, float bmatrx[3][3]); 
void rdm_reccel (float cx[], float wave, float rx[]); 
void rdm_rtm (float angle, float * axis, float mats[3][3]);
void rdm_rtod (float xr[3], float ctod, float s0[3], float ddinv[3][3],
               float dn[3], float * xf, float *yf);
void rdm_dtor (float xf, float yf, float s0[3], float dd[3][3], float xr[3]);
void rdm_corr (float xf, float yf, float ctod, float coswc, float sinwc, 
               int idtype, float twist, float tilt, float xcmid, float ycmid,
               float roff, float toff, float * xfd, float * yfd);
void rdm_ideal (float xfd, float yfd, float ctod, float coswc, float sinwc, 
               int idtype, float twist, float tilt, float xcmid, float ycmid,
               float roff, float toff, float * xf, float * yf);
void rdm_mmtoras (float xfd, float yfd, float x_cen, float y_cen,
                   float x_c, float y_c, float mm_rast_x, float mm_rast_y,
                   float * xd, float * yd);
void rdm_rastomm (float xd, float yd, float x_cen, float y_cen,
                   float x_c, float y_c, float mm_rast_x, float mm_rast_y,
                   float * xfd, float * yfd);
float rdm_vangl (float v1[3], float v2[3]);
float rdm_dot (float a[3], float b[3]);
void rdm_cross (float a[3], float b[3], float c[3]);
void rdm_minv3 (float a[3][3], float b[3][3], float *d);
void rdm_matmul (float a[3][3], float b[3][3], float c[3][3]);
void rdm_matvec (float v[3], float a[3][3], float b[3]);
void rdm_scalev (float a[3], float x, float b[3]);
void rdm_vadd (float a[3], float b[3], float c[3]);
void rdm_vdif (float a[3], float b[3], float c[3]);
void rdm_vnorm (float a[3], float b[3]);
