/* Copyright 1996-1999, CLRC Daresbury Laboratory.
   For licence conditions, see the file COPYING in the distribution.
 */

#ifndef __RDM_SYSTYP_H__
#define __RDM_SYSTYP_H__

/* The following flags are set where/as appropriate 

   LINKTYP             Mapping of Fortran called routine name to C routine name
   CHAR_STRING_TYPE    Way in which Fortran strings are passed to 'C'
   VMS                 Set for 'VMS' systems only

*/

/* Define Link name mapping type:

   LINKTYP = 1     Sun, Convex fx2800-alliant ...

                   xdlf_name  called as   xdlf_name_

   LINKTYP = 2     Ardent Titan ...

                   xdlf_name  called as  XDLF_NAME

   LINKTYP = 3     Vax, hpux, AIX ...

                   xdlf_name  called as  xdlf_name
*/

/* Define character string parameter passing type for use in 'xdlstr'
   routine:

   CHAR_STRING_TYPE = 1  Sun, Convex, Ardent Titan fx2800-alliant ...

                         call xdlstr (ch)  

                         passed as  xdlstr (ch_address, ch_len)

                         where ch_address is the address of the string
                         
                         and   ch_len is the length of the string

   CHAR_STRING_TYPE = 2  Vax ...

                         call xdlstr (ch)

                         passed as xdlstr (ch_descriptor)

                         where ch_descriptor is a pointer to a Vax character
                               descriptor structure.

*/

/* VMS type:

   Defined only for (Vax) VMS systems

*/

#ifndef _POSIX_SOURCE
#  define _POSIX_SOURCE		/* for posix-isms, where present */
#endif

/*Machine type defined*/

#if defined(vms) || defined (VMS) || defined (__VMS__) || defined (__vms__)
#  define found_mc
#  define VMS 1
#  define LINKTYP 3
#  define CHAR_STRING_TYPE 2
#endif

#if defined(hp700) || defined(hpux) || defined (__hpux)
#  define LINKTYP 3
#endif

#if defined(AIX) || defined (_AIX)
#  define LINKTYP 3
#endif

#ifdef __G77__
#  undef LINKTYP
#  define LINKTYP 1
#  undef CHAR_STRING_TYPE
#  define CHAR_STRING_TYPE 1
#endif

#ifndef LINKTYP
#  define LINKTYP 1
#endif

#ifndef CHAR_STRING_TYPE
#  define CHAR_STRING_TYPE 1
#endif

#endif /* ! __RDM_SYSTYP_H__ */
